package org.vtokarev.controller;


import org.vtokarev.domain.User;
import org.vtokarev.dto.BookingDto;
import org.vtokarev.service.BookingService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * The {@code BookingListServlet} class processes GET {@code bookingList} requests generated by users with GUEST role.
 * Gets {@link List<BookingDto>}, set it as an attribute and forward the control to {@code bookingList.jsp} view.
 *
 * @author Vyacheslav Tokarev
 */


@WebServlet(urlPatterns = "/bookingList", name = "bookingListServlet")
public class BookingListServlet extends HttpServlet {

    private BookingService bookingService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        bookingService = (BookingService) config.getServletContext().getAttribute("app/BookingService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        User user = (User)req.getSession().getAttribute("user");
        long userId = user.getId();

        boolean isActive = Boolean.parseBoolean(req.getParameter("isActive"));
        List<BookingDto> bookings = bookingService.getBookingsByUserId(userId, isActive);
        req.setAttribute("bookings", bookings);
        req.getRequestDispatcher("/WEB-INF/jsp/bookingList.jsp").forward(req, resp);
    }
}
